#!/usr/bin/env python 
import setpath

import unittest
import symbol
import brmtransformer
import brmtransformer
import tokenutils

# these two for debugging
import compiler.transformer as oldtransformer
import parser
import compiler
from brmtransformer import parse
import testdata
from bike import testdata as globaltestdata


from bike.testutils import getASTNodeFromSrc


# these tests just confirm that the parsetree is in the format expected
# by the addtoken module
class TestBrmtransformer(unittest.TestCase):

    def testClass_hasParsetree(self):
        src = testdata_class_nocomment
        parsetree = parser.suite(src).totuple(1)
        assert(getASTNodeFromSrc(src,"Class").parsetree == parsetree[1][1][1][1:])

    def testFuncdef_hasParsetree(self):
        src=testdata_func_nocomment
        parsetree = parser.suite(src).totuple(1)
        parse(src)
        #assert(getASTNodeFromSrc(src,"Function").parsetree == parsetree[1][1][1][1:])

    def testPass_hasParsetree(self):
        #print getASTNodeFromSrc(testdata_pass,"Pass").parsetree[0]
        assert getASTNodeFromSrc(testdata_pass,"Pass").parsetree[0]== (1,'pass',2)

    def testImport_hasParsetree(self):
        assert getASTNodeFromSrc(globaltestdata.FunctionRef,"Import").parsetree[0] == (1,'import',2)

    def testGetattr_parsetreeContainsCorrectParsetreeNodes(self):
        assert getASTNodeFromSrc(testdata.getattr,"Getattr").parsetree == ((1, 'a', 2), symbol.trailer, (23, '.', 2), (1, 'foo', 2))

    def testGetattr_parsetreeContainsCorrectParsetreeNodesWhenPartOfCallFunc(self):
        assert getASTNodeFromSrc(testdata.callfunc,"Getattr").parsetree == ((1, 'a', 2), symbol.trailer, (23, '.', 2), (1, 'foo', 2))


testdata_pass = """
pass
"""

testdata_class_nocomment = """
class bar:
    pass
"""

testdata_func_nocomment = """
def foo():
    pass
"""




if __name__ == "__main__":
    unittest.main()
    
