

class_and_method = """
class a:
    def foo():
        pass
"""

two_classes_with_same_named_method = """
class a:
    def foo():
        pass

class b:
    def foo():
        pass

"""

a_class_with_two_methods = """
class a:
    def foo():
        a=b
    def bah():
        pass
"""


source_with_all_ast_nodes = """
import foo
import sys
from a import b as c

def bah():
    pass

class x: pass
class y: pass

# comment
# comment b
class a:  # my comment
          # my second comment indented the same way
    # comment
    def foo(self):
        \"\"\" multi line doc string
        \"\"\"
        b = 3
        if a == 3:
            print "hello"  # this is a comment
            print >> sys.stderr, "this goes to stderr"
            if anifstatementSpreadOverMultipleLines and \\
               anotherone:
                pass

        else:
            self.foo()            # a comment here
            e = self.bah()    # a comment indented differently
        class a(x, 
                y):
            def f(): a.b = c
        return b
    def bah(self):
        self.a = ladida  #foo()
        pass
    def DEBUG(self):
        print >> sys.stderr, "\tfrees:", self.frees
"""


functionContaingObjectCreationAndMethodReferenceWithImport = """
import b.bah.TheClass
def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""


ObjectCreationAndMethodReference = """
from b.bah import TheClass
a = TheClass()
a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceWithImportOfNestedClass = """
import b.bah.TheClass

def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceButNotImported = """
import b.bah.DifferentClass

def foo():
    a = b.bah.TheClass()
    a.theMethod()
"""


functionContaingObjectCreationAndMethodReferenceWithImportAs = """
import b.bah.TheClass as MyClass

def foo():
    a = MyClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceWithImportFrom = """
from b.bah import TheClass

def foo():
    a = TheClass()
    a.theMethod()
"""

functionContaingObjectCreationAndMethodReferenceWithImportFromAs = """
from b.bah import TheClass as MyClass

def foo():
    a = MyClass()
    a.theMethod()
"""

FunctionContainingMethodReferenceButNotSameAsOneImported = """
from b.bah import TheClass as MyClass

def foo():
    a = TheClass()
    a.theMethod()
"""

FunctionContainingMethodReferenceWithFromImportStar = """
from b.bah import *
a = TheClass()
a.theMethod()
"""

ObjectCreatedInParentScopeToMethodReference = """
from b.bah import TheClass
a = TheClass()
def foo():
    a.theMethod()
"""

ObjectCreatedInChildScopeToMethodReference = """
from b.bah import TheClass
a = AnotherClass()
def foo():
    a = TheClass()
a.theMethod()
"""

ObjectCreatedInParentScopeAfterMethodReference = """
class TheClass:
    def theMethod():
        pass

def foo():
    a.theMethod()
a = TheClass()
"""


ObjectCreatedInFunctionAndUsedByCaller = """
class TheClass:
    def theMethod():
        pass
def foo():
    b = TheClass()
    return b
a = foo()
a.theMethod()
"""


ObjectReturnedByFunctionAndUsedByCaller = """
class TheClass:
    def theMethod():
        pass
def foo():
    return TheClass()
a = foo()
a.theMethod()
"""

ObjectReturnedByFunctionAndUsedByCallerInOtherFunction = """
class TheClass:
    def theMethod():
        pass
def bah():
    return TheClass()
def foo():
    a = bah()
    a.theMethod()
"""

ObjectReturnedByFunctionAndUsedByCallerInPreviousFunction = """
class TheClass:
    def theMethod():
        pass
class NotTheClass:
    def theMethod():
        pass

def foo():
    a = bah()
    a.theMethod()

def bah():
    return TheClass()
"""

ObjectRefWithNoDeducableType = """
import blah
class TheClass:
    def theMethod():
        pass

def foo():
    a = blah.foobah()
    a.theMethod()
"""

FunctionWithOneElement = """
import blah
def foo():
    blah.theMethod()
"""

FunctionReturnsArrayExpr = """
import a
class TheClass:
    def theMethod(self):
        pass

def bah():
    return a[35]

b = bah()
b.theMethod()
"""

ClassNestedInFunction = """
def theFunction():
    class TheClass:
        def theMethod(self):
            pass
    a = TheClass()
    a.theMethod()
"""

RefCalledOnClassInstanceCreation = """
class TheClass:
    def theMethod(self): pass
TheClass().theMethod()
"""

MethodRefIsPartOfABiggerCompoundCall = """
class TheClass:
    def theMethod(self): return AnotherClass()
TheClass().theMethod().anotherMethod()
"""


ClassDefWithInheritanceHierarchy = """
from b.bah import DifferentClass
class TheClass(foo.bah):
    def theMethod(self):
        pass
"""

ClassDefWithCompoundInheritanceHierarchy = """
class TheClass(foo.bah):
    def theMethod(self):
        pass
"""



RecursiveFunctionDef = """
class TheClass:
    def theMethod(self):
        pass

def foo(a):
    return foo(a)
"""

FunctionCallReturnsInstance="""
from foo import e
class TheClass:
    def theMethod(self):
        pass
ast = e().f(src)
"""

ClassWithRefToOwnMethod="""
class TheClass:
    def theMethod(self):
        pass
    def anotherMethod(self):
        self.theMethod()
"""

ClassInAClass ="""
class TheClass:
    class AnotherClass:
        pass
    def theMethod(self):
        pass
"""

StreamToStderr = """
def DEBUG(self):
    print >> sys.stderr, "\tfrees:", self.frees

"""



testdata_inheritance ="""
class base:
    pass

class derived(base):
    pass

"""


TheClass = """
class TheClass:
    def theMethod(self):
        pass
    def differentMethod(self):
        pass

class DifferentClass:
    def theMethod(self):
        pass
"""

ClassWithNestedInheritanceSpec = """
import b

class DerivedClass(b.bah.TheClass):
    pass

"""


ClassDerivedFromOtherClassInSameModule = """
class TheClass:
    pass

class DerivedClass(TheClass):
    pass

"""

MethodCalledOnDerivedClassInstance = """
import b

class DerivedClass(b.bah.TheClass):
    pass

class DerivedDerivedClass(DerivedClass):
    pass

theInstance = DerivedDerivedClass()
theInstance.theMethod()
"""

MethodOverriddenOnDerivedClassInstance = """
from b.bah import TheClass as BaseClass

class DerivedClass(BaseClass):
    pass

class DerivedDerivedClass(DerivedClass):
    def theMethod(self):
        print \"hello\"

"""

ClassInstanceIsAttributeOfSelf="""
class TheClass:
    def theMethod(self):
        pass

class AnotherClass:
    def __init__(self):
        self.a = TheClass()
    def anotherFn(self):
        self.a.theMethod()
"""


GetattrWithNoWayToDeduceType ="""
class TheClass:
    def theMethod(self):
        pass
a = TheClass

a.b.bah = 3
"""

ClassHierarchy = """

class root:
    def theMethod():
        pass

class a(root):
    def theMethod():
        pass
    

class b(root):
    pass

class TheClass(b):
    def theMethod():
        pass

ainstance = a()
ainstance.theMethod()

binstance = b1()
binstance.theMethod()

rootinstance = root()
rootinstance.theMethod()

"""

IndirectRecursiveFunctionCall="""
def foo():
    return bah()
    
def bah():
    return baz()

def baz():
    return foo()

a = foo()
"""

RecursiveFunctionCall = """
def get_docstring(self, node, n=None):
    if n is None:
        n = node[0]
        node = node[1:]
    if n == symbol.suite:
        if len(node) == 1:
            return self.get_docstring(node[0])
        for sub in node:
            if sub[0] == symbol.stmt:
                return self.get_docstring(sub)
        return None
    if n == symbol.file_input:
        for sub in node:
            if sub[0] == symbol.stmt:
                return self.get_docstring(sub)
        return None
    if n == symbol.atom:
        if node[0][0] == token.STRING:
            s = ''
            for t in node:
                s = s + eval(t[1])
            return s
        return None
    if n == symbol.stmt or n == symbol.simple_stmt \
       or n == symbol.small_stmt:
        return self.get_docstring(node[0])
    if n in _doc_nodes and len(node) == 1:
        return self.get_docstring(node[0])
    return None
"""

linebreak = """
def foo():
    if foo.bah and \\
       babble:
        pass
"""
linebreak_outputIfTokensMoved = """
def foo():
    if foo.bah and \\
     babble:
        pass
"""

BaseClassNotInAST = """
class TheClass(notInAst):
    def theMethod():
        pass
"""

TheClassOnEndOfNestedExpression = """
class TheClass:
    pass

a.b.c.TheClass    # Shouldn't be renamed
"""
RaiseClassException = """
class TheClass:
    pass

raise TheClass, \"hello mum\"
"""

Function = """
def theFunction():
    pass
"""

FunctionRef = """
import b.bah.theFunction
b.bah.theFunction()
"""

ImportFunctionWithTwoImportsInSameStatement = """
import foo.yadayada, b.bah.theFunction
"""

FunctionRefImportedViaFrom = """
from b.bah import theFunction
theFunction()
"""

theClassAsAFunction = """
def theClass():
    pass
"""

wierdSubclassProblem="""
from b.bah import TheClass, theClass

class DerivedClass(TheClass):
    pass
"""

blankLineBetweenObjCreationAndMethodCall="""
class TheClass:
    def theMethod(self):
        pass

a = myunfindableclass()

a.theMethod()
"""

method_with_NoneAsDefaultArg="""
class TheClass:
    def theMethod(self, root, flist, stack=None):
        pass
"""
